//
//  VilloRequest.m
//  villo
//
//  Created by Philip Bernstein on 4/10/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "VilloRequest.h"

@implementation VilloRequest
@synthesize urlString, connectionData, request, connection, completionHandler;

-(id)initWithURL:(NSString *)URL method:(NSString *)method parameters:(NSDictionary *)parameters completionHandler:(VilloRequestCompletionHandler)handler
{
    self = [super init];
    
    if (self)
    {
        self.urlString = URL;
        completionHandler = handler;
        self.connectionData = [[NSMutableData alloc] init];
        self.request = [[NSMutableURLRequest alloc] init];
        if ([method isEqualToString:@"POST"])
        {
            [request setHTTPMethod:@"POST"];
            [request setURL:[NSURL URLWithString:urlString]];
            NSString *postBody = @"";
            if (parameters)
            {
            for (NSString *parameter in [parameters allKeys])
            {
                NSString *param = [NSString stringWithFormat:@"%@=%@&", [parameter stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding], [[parameters objectForKey:parameter] stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding]];
                postBody = [postBody stringByAppendingString:param];
            }
                NSLog(@"POST BODY: %@", postBody);
            [request setHTTPBody:[postBody dataUsingEncoding:NSUTF8StringEncoding]];
            }

        }
        else if ([method isEqualToString:@"GET"])
        {
            [request setHTTPMethod:@"GET"];
            if (parameters)
            {
            if ([urlString rangeOfString:@"?"].location == NSNotFound)
            {
                urlString = [urlString stringByAppendingString:@"?"];
            }
            for (NSString *parameter in [parameters allKeys])
            {
                NSString *param = [NSString stringWithFormat:@"%@=%@&", [parameter stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding], [[parameters objectForKey:parameter] stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding]];
                urlString = [urlString stringByAppendingString:param];
            }
            }
            [request setURL:[NSURL URLWithString:urlString]];

        }
        if (request)
        {
            self.connection = [[NSURLConnection alloc] initWithRequest:self.request delegate:self];
        }
    }
    
    return self;
}
- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
	[self.connectionData appendData:data];
}
- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error {
	
	if (self.completionHandler) {
		self.completionHandler(self, error, self.urlString, nil);
	}
	
	[[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:NO];
}
- (void)connectionDidFinishLoading:(NSURLConnection *)connection {
	
	if (self.completionHandler) {
		self.completionHandler(self, nil, self.urlString, [NSData dataWithData:self.connectionData]);
	}
	
	[[UIApplication sharedApplication] setNetworkActivityIndicatorVisible:NO];
	
	// Cleanup. Handy if you modify this class to support multiple connections from the same instance.
	self.connectionData = nil;
	self.connectionData = nil;
}
- (void)cancel {
	
	[self.connection cancel];
	
	self.connectionData = nil;
	self.connection = nil;
	
}


@end
